// 001 visual livebindings

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

unit u_vlb_09_c_object_tadapterbindsource;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs
  , Data.Bind.Components, Data.Bind.ObjectScope, Vcl.Grids,
  Data.Bind.EngExt, Vcl.Bind.DBEngExt, Vcl.Bind.Grid, System.Rtti,
  System.Bindings.Outputs, Vcl.Bind.Editors, Vcl.ExtCtrls, Vcl.Buttons,
  Vcl.Bind.Navigator, Data.Bind.Grid, Vcl.Bind.GenData, Data.Bind.GenData,
  Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    BindingsList1: TBindingsList;
    DataGeneratorAdapter1: TDataGeneratorAdapter;
    AdapterBindSource1: TAdapterBindSource;
    EditFirstName: TEdit;
    LinkControlToField1: TLinkControlToField;
    EditAge: TEdit;
    LinkControlToField2: TLinkControlToField;
    DataGeneratorAdapter2: TDataGeneratorAdapter;
    AdapterBindSource2: TAdapterBindSource;
    StringGridAdapterBindSource2: TStringGrid;
    LinkGridToDataSource1: TLinkGridToDataSource;
    NavigatorAdapterBindSource2: TBindNavigator;
    procedure AdapterBindSource1CreateAdapter(Sender: TObject;
      var ABindSourceAdapter: TBindSourceAdapter);
    procedure AdapterBindSource2CreateAdapter(Sender: TObject;
      var ABindSourceAdapter: TBindSourceAdapter);
  private
  public
  end;

var
  Form1: TForm1;

implementation
   uses System.Generics.Collections
       , u_c_person_list;


  {$R *.dfm}

    var g_c_one_person: c_person= Nil;

    procedure TForm1.AdapterBindSource1CreateAdapter(Sender: TObject;
        var ABindSourceAdapter: TBindSourceAdapter);
      begin
        g_c_one_person:= f_c_create_and_fill_person('LEWIS', 33, True);
        aBindSourceAdapter:= tObjectBindSourceAdapter<c_person>.Create(
            Nil, g_c_one_person);
      end; // AdapterBindSource1CreateAdapter


    var g_c_person_list: tObjectList<c_person>= Nil;

    procedure TForm1.AdapterBindSource2CreateAdapter(Sender: TObject;
        var ABindSourceAdapter: TBindSourceAdapter);
      begin
        g_c_person_list:= f_c_create_and_fill_person_list;
        aBindSourceAdapter:= tListBindSourceAdapter<c_person>.Create(
            Nil, g_c_person_list);
      end; // AdapterBindSource2CreateAdapter

end.
